
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 *
 * IBM Tivoli Access Manager for Operating Systems 6.0.0
 * 5698-PDO
 * Licensed Materials - Property of IBM
 * 
 * (C) Copyright IBM Corp. 2000,2006. All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with
 * IBM Corp.
 *
*/

static char sccsid[] = "@(#)94       1.20  src/oss/kazn/kail/s390_linux_2/syscall_glue.c, oss.kazn.src, oss600, 060907a 8/22/06 12:01:32";
#include <linux/module.h>

#include <linux/kernel.h>

#include <linux/types.h>


#include <asm/ptrace.h>

#include <asm/uaccess.h>
typedef struct kail_vfs
{
    void *mnt;
    void *mnt_parent;
    char devname[64];
} kail_vfs_t;






typedef struct {
        long val[2];
} kail_fsid_t;

typedef struct kail_fid {
    uint32_t fid_ino;
    uint32_t fid_gen;
    uint16_t fid_flags;
    uint16_t fid_data_len;

    char fid_data[(sizeof(char) * 64)];
} kail_fid_t;

typedef mode_t kail_fmode_t;
typedef dev_t kail_dev_t;
typedef void * kail_vnodeH_t;
typedef struct _kail_rfid {
    uint32_t ctime;
    kail_fsid_t fsid;
    kail_fid_t fid;
} kail_rawFid_t;
typedef struct _kail_cred {

        uid_t uid,euid,suid,fsuid;
        gid_t gid,egid,sgid,fsgid;
        int ngroups;
        int cr_ref;
        gid_t groups[32 ];
} kail_cred_t;

typedef int64_t kail_authID_t;
enum kail_ftypes { KAIL_FTYPE_NONE, KAIL_FTYPE_FILE, KAIL_FTYPE_DIR,
             KAIL_FTYPE_BLKDEV, KAIL_FTYPE_CHARDEV, KAIL_FTYPE_LNK,
             KAIL_FTYPE_SOCK, KAIL_FTYPE_BAD, KAIL_FTYPE_FIFO,
             KAIL_FTYPE_MPC, KAIL_FTYPE_OTHER};
typedef enum kail_ftypes kail_ftypes_t;

typedef struct _kail_fattr {
    kail_authID_t uid;
    kail_authID_t gid;
    kail_ftypes_t ftype;
    kail_fmode_t mode;
    uint16_t links;
    uint16_t attrFlags;
    dev_t dev;
    kail_vfs_t check_vfsp;
} kail_fattr_t;




extern volatile struct timespec *kail_xtime;





extern asmlinkage int (*kail_printk)(const char *, ...);
extern asmlinkage int (*kail_sprintf)(char * buf, const char * fmt, ...);
extern asmlinkage int (*kail_do_fork)(unsigned long, unsigned long, struct pt_regs *, unsigned long);


extern asmlinkage int kail_kernel_thread(int (*)(void *), void *,unsigned long);
extern asmlinkage int kail_kill_proc(pid_t, int, int);
extern asmlinkage long kail_strncpy_from_user(char *, const char *, long);
extern asmlinkage long kail_strncpy_from_DND(char *, void *, long);
extern unsigned long FASTCALL(kail_copy_to_user(void *, const void *, unsigned long));
extern unsigned long FASTCALL(kail_copy_from_user(void *, const void *, unsigned long));

extern void FASTCALL(kail_kernel_free(void *,unsigned long));
extern void * FASTCALL(kail_kernel_malloc(unsigned long));





extern asmlinkage void kail_mutex_init(void **);
extern void FASTCALL(kail_mutex_lock(void **));
extern int FASTCALL(kail_mutex_trylock(void **));
extern void FASTCALL(kail_mutex_unlock(void **));
extern asmlinkage void kail_mutex_destroy(void **);

extern asmlinkage void kail_cond_init(void **);
extern void FASTCALL(kail_wake_up(void **));
extern void FASTCALL(kail_cond_wait(void **, void **));
extern int FASTCALL(kail_cond_wait_intr(void **, void **));
extern asmlinkage int kail_condTimedWait(void **, void **, int64_t, int);
extern asmlinkage void kail_cond_destroy(void **);

extern asmlinkage void kail_iclock_init(void **);
extern void FASTCALL(kail_iclock_lock(void **));
extern void FASTCALL(kail_iclock_unlock(void **));
extern int FASTCALL(kail_iclock_trylock(void **));
extern asmlinkage void kail_iclock_destroy(void **);

extern void FASTCALL(kail_iclock_cond_wait(void **,void **));

extern asmlinkage int kail_current_pid(void);
extern asmlinkage int kail_current_tid(void);
extern asmlinkage int kail_current_Ppid(void);
extern int FASTCALL(kail_tid_to_pid(int));
extern pid_t FASTCALL(kail_pid_get_epid(pid_t));
extern void FASTCALL(kail_pid_delete(pid_t));
extern void FASTCALL(kail_epid_delete(pid_t));
extern void FASTCALL(kail_pid_add(pid_t,pid_t));


extern asmlinkage int kail_current_uid(void);
extern asmlinkage int kail_current_euid(void);
extern asmlinkage int kail_current_suid(void);
extern asmlinkage int kail_current_gid(void);
extern asmlinkage int kail_current_egid(void);
extern int FASTCALL(kail_current_files_close_on_exec(int));

extern asmlinkage int kail_socket_protocol(void *);
extern asmlinkage int kail_socket_getname(void *,void *,int *,int);

extern int FASTCALL(kail_fd_to_dev(int, dev_t *));
extern int FASTCALL(kail_fd_to_name(int, char **, int *));
extern int FASTCALL(kail_fd_to_socket(int,void **));

extern int FASTCALL(kail_socket_shutdown(void *));




extern int FASTCALL(kail_check_pid(int));
extern int FASTCALL(kail_get_pid_pgrp(int,int *));
extern int FASTCALL(kail_get_pid_uid(int,int *,int *));
extern void FASTCALL(kail_scan_procs(void *));

extern asmlinkage void kail_daemonize(const char *);
extern asmlinkage int kail_total_ram_mb(void);
extern void FASTCALL(kail_atomic_add(int,void *));

extern asmlinkage int kail_kernel_address_mode(void);






extern asmlinkage int kail_decomposePath(char *, int, kail_rawFid_t *, int *, kail_rawFid_t *, int *, kail_fattr_t *, kail_vnodeH_t *);
extern asmlinkage int kail_LookupFidAndDir(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, int *);
extern asmlinkage int kail_lookupFidsAndInfo(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, kail_vnodeH_t *, kail_vnodeH_t *, int *);
extern asmlinkage int kail_dirFidToPathFids( kail_rawFid_t *, kail_rawFid_t **, int *);
extern asmlinkage int kail_unixDescToRawFid( int , kail_rawFid_t *);
extern asmlinkage int kail_vnodesToFids( kail_vnodeH_t, kail_vnodeH_t, kail_rawFid_t *, kail_rawFid_t *, kail_rawFid_t **, int *, kail_fattr_t *);
extern asmlinkage int kail_makeFidChain(void *, kail_rawFid_t *, int *, const kail_cred_t *, int );


struct group_info;
extern gid_t * FASTCALL(kail_groups_blocks(struct group_info *,int));
extern int FASTCALL(kail_groups_ngroups(struct group_info *));
extern int FASTCALL(kail_groups_nblocks(struct group_info *));







struct kail_register_chrdev_parameters {
        unsigned int dev_number;
        char *name;
        void *ownerp;
        void *readp;
        void *writep;
        void *ioctlp;



        void *openp;
        void *releasep;
        unsigned int ioctl_cnt;
        unsigned int *ioctl_cmds;
} ;

extern asmlinkage int kail_register_chrdev(struct kail_register_chrdev_parameters *, void **);
extern asmlinkage int kail_unregister_chrdev(struct kail_register_chrdev_parameters *, void *);
extern int FASTCALL(kail_minor(void *));

extern asmlinkage int kail_file_read(char *, kail_vnodeH_t *,char *, long, long);
extern asmlinkage void kail_write_log(const char *,const char *, int, int);
extern asmlinkage void kail_log_init(const char *);

extern asmlinkage int kail_pathToFullPath( char *, int , char **, char *,int);
extern void * FASTCALL(kail_unixDescToVnode(int));
extern void FASTCALL(kail_releVnode(void *));
extern void FASTCALL(kail_holdVnode(void *));
extern asmlinkage char * kail_readSymLink(char *, int *);



extern asmlinkage int kail_vfs_mounted(kail_vfs_t *);
extern asmlinkage int kail_vfs_check(kail_vfs_t *);


typedef struct {
        void *alloc;
        void *free;
        void *fcc_find;
        void *fcc_add;
} kail_call_back_t;

extern asmlinkage void kail_call_backs(kail_call_back_t *);
extern asmlinkage void kail_kernel_interface(void);
extern asmlinkage void kail_kernel_interface_shutdown(void);

typedef asmlinkage long (* sys_call_fn)();
struct kail_syscall_prepost {
        int call_index;
        sys_call_fn call_pre;
        sys_call_fn call_post;
};

extern int struct_cppath_size;

struct kail_lsmhooks {
        int lsmhook_index;
        sys_call_fn lsmhook_pre;
        sys_call_fn lsmhook_post;
};
extern asmlinkage int kail_trap_syscalls(struct kail_syscall_prepost *,struct kail_lsmhooks *);



extern asmlinkage void kail_restore_syscalls(void);

struct nameidata;
struct kail_datanameidata {
        char cdata[4];
        char *path;
        struct nameidata *nd;
};
#define KAIL_LOOKUP_BIT 0x40000000
#if defined(LINUX_RHEL4) || defined(LINUX_SLES10)
#define SET_LOOKUP_FLAG(n) (n)->intent.open.flags = KAIL_LOOKUP_BIT;
#define CLEAR_LOOKUP_FLAG(n) (n)->intent.open.flags &= ~KAIL_LOOKUP_BIT;
#define CHECK_LOOKUP_FLAG(n) ((n)->intent.open.flags == KAIL_LOOKUP_BIT)
#endif 
#ifdef LINUX_SLES9
#define SET_LOOKUP_FLAG(n)
#define CLEAR_LOOKUP_FLAG(n)
#define CHECK_LOOKUP_FLAG(n)
#endif 
struct syscall_glue_table {
        long syscall_index;
        sys_call_fn syscall_glue_pre;
        sys_call_fn syscall_glue_post;
        sys_call_fn syscall_glue_pre_post;





};
extern struct syscall_glue_table kail_syscall_glue_list[];

struct syscall_table {
        sys_call_fn orig_syscall;
        sys_call_fn syscall_pre;
        sys_call_fn syscall_post;



};
extern struct syscall_table kail_syscall_list[];
typedef unsigned int uid32_t;
typedef unsigned int gid32_t;
struct kail_lsmhooks_table {
        sys_call_fn lsmhooks_pre;
        sys_call_fn lsmhooks_post;
};
extern struct kail_lsmhooks_table kail_lsmhooks_list[];
long kail_umount_glue_pre(char * p1)
{
        long rc;
        ;

        0;
        0;
       
        rc = (*(kail_syscall_list[3]).syscall_pre)( p1);
        0;

        if (!rc) {
                0;
                rc = (*(kail_syscall_list[3]).orig_syscall)(p1);
                0;
                return rc;
        }
        else {
                0;
                return rc;
        }
}

long kail_umount_glue_post(char * p1)
{
        long rc;
        ;

        0;

        0;
        rc = (*(kail_syscall_list[3]).orig_syscall)(p1);
        0;

        0;
       
        rc = (*(kail_syscall_list[3]).syscall_post)(rc, p1);
        0;

        0;
        return rc;
}

long kail_umount_glue_pre_post(char * p1)
{
        long rc;
        ;

        0;
        0;
       
        rc = (*(kail_syscall_list[3]).syscall_pre)( p1);
        0;

        if (!rc) {
                0;
                rc = (*(kail_syscall_list[3]).orig_syscall)(p1);
                0;

                0;
               
                rc = (*(kail_syscall_list[3]).syscall_post)(rc, p1);
                0;
                return rc;
        }
        else {
                0;
                return rc;
        }
}
long kail_kill_glue_pre(pid_t p1,int p2)
{
        long rc;
        ;

        0;
        0;
       
        rc = (*(kail_syscall_list[0]).syscall_pre)( p1,p2);
        0;

        if (!rc) {
                0;
                rc = (*(kail_syscall_list[0]).orig_syscall)(p1,p2);
                0;
                return rc;
        }
        else {
                0;
                return rc;
        }
}

long kail_kill_glue_post(pid_t p1,int p2)
{
        long rc;
        ;

        0;

        0;
        rc = (*(kail_syscall_list[0]).orig_syscall)(p1,p2);
        0;

        0;
       
        rc = (*(kail_syscall_list[0]).syscall_post)(rc, p1,p2);
        0;

        0;
        return rc;
}

long kail_kill_glue_pre_post(pid_t p1,int p2)
{
        long rc;
        ;

        0;
        0;
       
        rc = (*(kail_syscall_list[0]).syscall_pre)( p1,p2);
        0;

        if (!rc) {
                0;
                rc = (*(kail_syscall_list[0]).orig_syscall)(p1,p2);
                0;

                0;
               
                rc = (*(kail_syscall_list[0]).syscall_post)(rc, p1,p2);
                0;
                return rc;
        }
        else {
                0;
                return rc;
        }
}
long kail_tkill_glue_pre(pid_t p1,int p2)
{
        long rc;
        ;

        0;
        0;
       
        rc = (*(kail_syscall_list[1]).syscall_pre)( p1,p2);
        0;

        if (!rc) {
                0;
                rc = (*(kail_syscall_list[1]).orig_syscall)(p1,p2);
                0;
                return rc;
        }
        else {
                0;
                return rc;
        }
}

long kail_tkill_glue_post(pid_t p1,int p2)
{
        long rc;
        ;

        0;

        0;
        rc = (*(kail_syscall_list[1]).orig_syscall)(p1,p2);
        0;

        0;
       
        rc = (*(kail_syscall_list[1]).syscall_post)(rc, p1,p2);
        0;

        0;
        return rc;
}

long kail_tkill_glue_pre_post(pid_t p1,int p2)
{
        long rc;
        ;

        0;
        0;
       
        rc = (*(kail_syscall_list[1]).syscall_pre)( p1,p2);
        0;

        if (!rc) {
                0;
                rc = (*(kail_syscall_list[1]).orig_syscall)(p1,p2);
                0;

                0;
               
                rc = (*(kail_syscall_list[1]).syscall_post)(rc, p1,p2);
                0;
                return rc;
        }
        else {
                0;
                return rc;
        }
}
long kail_umount2_glue_pre(char * p1,int p2)
{
        long rc;
        ;

        0;
        0;
       
        rc = (*(kail_syscall_list[4]).syscall_pre)( p1,p2);
        0;

        if (!rc) {
                0;
                rc = (*(kail_syscall_list[4]).orig_syscall)(p1,p2);
                0;
                return rc;
        }
        else {
                0;
                return rc;
        }
}

long kail_umount2_glue_post(char * p1,int p2)
{
        long rc;
        ;

        0;

        0;
        rc = (*(kail_syscall_list[4]).orig_syscall)(p1,p2);
        0;

        0;
       
        rc = (*(kail_syscall_list[4]).syscall_post)(rc, p1,p2);
        0;

        0;
        return rc;
}

long kail_umount2_glue_pre_post(char * p1,int p2)
{
        long rc;
        ;

        0;
        0;
       
        rc = (*(kail_syscall_list[4]).syscall_pre)( p1,p2);
        0;

        if (!rc) {
                0;
                rc = (*(kail_syscall_list[4]).orig_syscall)(p1,p2);
                0;

                0;
               
                rc = (*(kail_syscall_list[4]).syscall_post)(rc, p1,p2);
                0;
                return rc;
        }
        else {
                0;
                return rc;
        }
}
long kail_tgkill_glue_pre(pid_t p1,pid_t p2,int p3)
{
        long rc;
        ;

        0;
        0;
       
        rc = (*(kail_syscall_list[2]).syscall_pre)( p1,p2,p3);
        0;

        if (!rc) {
                0;
                rc = (*(kail_syscall_list[2]).orig_syscall)(p1,p2,p3);
                0;
                return rc;
        }
        else {
                0;
                return rc;
        }
}

long kail_tgkill_glue_post(pid_t p1,pid_t p2,int p3)
{
        long rc;
        ;

        0;

        0;
        rc = (*(kail_syscall_list[2]).orig_syscall)(p1,p2,p3);
        0;

        0;
       
        rc = (*(kail_syscall_list[2]).syscall_post)(rc, p1,p2,p3);
        0;

        0;
        return rc;
}

long kail_tgkill_glue_pre_post(pid_t p1,pid_t p2,int p3)
{
        long rc;
        ;

        0;
        0;
       
        rc = (*(kail_syscall_list[2]).syscall_pre)( p1,p2,p3);
        0;

        if (!rc) {
                0;
                rc = (*(kail_syscall_list[2]).orig_syscall)(p1,p2,p3);
                0;

                0;
               
                rc = (*(kail_syscall_list[2]).syscall_post)(rc, p1,p2,p3);
                0;
                return rc;
        }
        else {
                0;
                return rc;
        }
}
long kail_mount_glue_pre(char * p1,char * p2,char * p3,unsigned long p4,void * p5)
{
        long rc;
        ;

        0;
        0;
       
        rc = (*(kail_syscall_list[5]).syscall_pre)( p1,p2,p3,p4,p5);
        0;

        if (!rc) {
                0;
                rc = (*(kail_syscall_list[5]).orig_syscall)(p1,p2,p3,p4,p5);
                0;
                return rc;
        }
        else {
                0;
                return rc;
        }
}

long kail_mount_glue_post(char * p1,char * p2,char * p3,unsigned long p4,void * p5)
{
        long rc;
        ;

        0;

        0;
        rc = (*(kail_syscall_list[5]).orig_syscall)(p1,p2,p3,p4,p5);
        0;

        0;
       
        rc = (*(kail_syscall_list[5]).syscall_post)(rc, p1,p2,p3,p4,p5);
        0;

        0;
        return rc;
}

long kail_mount_glue_pre_post(char * p1,char * p2,char * p3,unsigned long p4,void * p5)
{
        long rc;
        ;

        0;
        0;
       
        rc = (*(kail_syscall_list[5]).syscall_pre)( p1,p2,p3,p4,p5);
        0;

        if (!rc) {
                0;
                rc = (*(kail_syscall_list[5]).orig_syscall)(p1,p2,p3,p4,p5);
                0;

                0;
               
                rc = (*(kail_syscall_list[5]).syscall_post)(rc, p1,p2,p3,p4,p5);
                0;
                return rc;
        }
        else {
                0;
                return rc;
        }
}
